/*----------------------------------------------------------------------+
|									|
|  Copyright (c) 1985-93;  Bentley Systems, Inc., All rights reserved.	|
|									|
| "MicroStation", "MDL", and "MicroCSL" are trademarks of Bentley	|
|  Systems, Inc.							|
|									|
|  Limited permission is hereby granted to reproduce and modify this	|
|  copyrighted material provided that the resulting code is used only 	|
|  in conjunction with Bentley Systems products under the terms of the	|
|  license agreement provided therein, and that this notice is retained	|
|  in its entirety in any such reproduction or modification.		|
|									|
+----------------------------------------------------------------------*/
/*----------------------------------------------------------------------+
|									|
|   Current Revision:							|
|   $Workfile:   msregion.fdf  $
|   $Revision:   6.1  $  $Date:   30 Aug 1995 08:10:52  $
|									|
+----------------------------------------------------------------------*/
#ifndef __msregionFDF__
#define __msregionFDF__

/*----------------------------------------------------------------------+
|									|
|   Header File Dependencies						|
|									|
+----------------------------------------------------------------------*/

#if !defined (__dloadlibH__)
#include "dloadlib.h"
#endif

#if !defined (__mdlH__)
#include "mdl.h"
#endif

#if !defined (__mselemsH__)
#include "mselems.h"
#endif

#if !defined (__mdlbsplnH__)
#include "mdlbspln.h"
#endif
/*======================================================================+
|									|
|   Function Definitions						|
|									|
+======================================================================*/
int mdlRegion_floodFill
(
MSElementDescr	**outEdPP,		/* <= element bounding region */
MSBsplineCurve	*outCurveP,		/* <= B-Curve bounding region */
MSElementDescr	*inEdP,			/* => seed element */
Dpoint3d	*normalP,		/* => normal to plane */
Dpoint3d	*seedPointP,		/* => seed point */
double		closureTolerance,	/* => closure tolerance */
MdlFunctionP	stopFunction		/* => stop function (or NULL) */
);

int mdlPolygon_divide		    /* <= SUCCESS, MDLERR_INSFMEMORY, etc... */
(
PolygonLink     **outPolygonPP,     /* <= Linked list of montonic polygons */
PolygonLink     *inPolygonP	    /* => Single Polygon (may have holes) */
);

void mdlPolygon_free		    /* Free up a dlmSystem_mdlMalloc'd polygon. */
(
PolygonLink   *polygonListP
);

int mdlPolygon_pointInside /* <= 0 if outside, -1 of on, 1 if inside */
(
double		*pt,		       /* => test point, 2d or 3d */
double		*points,	       /* => closed polygon points, 2d or 3d */
int		numPoints,	       /* => number of points in polygon */
int		closed,		       /* => TRUE if the polygon is closed */
int		dimension,	       /* => 2 or 3 */
double		onTolerance	       /* => on Polygon tolerance */
);

#endif
